\ProvidesPackage{macros}[Yes, I have my own macros because I'm FANCY like that... What do you want from me?]

% Aesthetic decisions
\let\epsilon\varepsilon
\let\phi\varphi


% For multinomials: arg1 is m (number of k's), arg2 is min (minimum integer size of each k i.e. greater or equal to 0), arg3 is n (what the m k's must sum up to)
% ALL ARGS ARE MANDATORY because I was too lazy to use xparse in order to make them all optional
\newcommand{\multinom}[3]{ % \multinom[<m>][<min>][<n>]
    \ensuremath{
        \sum_{\substack{k_1 + \cdots + k_{#1} = {#3} \\ k_1, \ldots, k_{#1} \geq #2 }} 
        \binom{#3}{k_1, \ldots, k_{#1}}
    }
}

% For combinations with repetitions. From Stack Overflow. Link to original post:
% https://tex.stackexchange.com/questions/5816/multiset-notation-in-latex
% TODO: figure out how this works + difference between \def and \newcommand + difference between TeX, LaTeX, MikTeX, pdfTeX, ...
\def\multiset#1#2{\ensuremath{\left(\kern-.3em\left(\genfrac{}{}{0pt}{}{#1}{#2}\right)\kern-.3em\right)}}


% For numbered cells using the Tabular package. From Stack Exchange by user koleygr
% https://tex.stackexchange.com/questions/477554/numbering-in-cells
\newcommand{\numcell}[2]{\begin{tabular}{@{}c@{}c@{}}&\tiny #2\\\normalsize #1&\end{tabular}}

\newcommand{\sf}[1]{
    \ensuremath{
        \sum_{n \geq 0} {#1}_n X^n
    }
}

% For simpler equation numbering (1) instead of (1.1)
\renewcommand{\theequation}{\arabic{equation}}

% Dot product - for Geometry, Algebra, and Analysis
\newcommand{\dot}[2]{
    \ensuremath{
        \left\langle \vec{#1} \mid \vec{#2} \right\rangle
    }
}

% Absolute value
\newcommand{\abs}[1]{
    \ensuremath{
        \left\lvert #1 \right\rvert
    }
}

% Pour tout, cardinalité d'un ensemble
\newcommand{\card}[1]{
    \abs{#1}
}

% Pour tout, module d'un complexe
\newcommand{\modulus}[1]{
    \abs{#1}
}

% Pour géométrie et analyse, norme d'un vecteur
\newcommand{\norm}[1]{
    \ensuremath{
        \left\lVert #1 \right\rVert
    }
}

% Pour algèbre, théorème de Lagrange et actions de groupe, le nombre de classes à droite (et de classes à gauche)
\newcommand{\index}[2]{
    \ensuremath{
        \left\[ #1 : #2 \right\]
    }
}

% Pour algèbre, ordre d'un élément, d'un groupe
\newcommand{\ord}{
    \ensuremath{
        \text{ ord}
    }
}

% Symbol for quotient spaces and inline fractions
% Authors: Yossi Farjoun, Werner. Source:
% https://tex.stackexchange.com/questions/4624/a-symbol-for-the-quotient-of-two-objects
\newcommand{\slant}[2]{
    {$#1$\left/\raisebox{-.2em}{$#2$}\right.}
}

% Function restriction typesetting pulled of Stack Exchange
% Author: egreg  -  Link: https://tex.stackexchange.com/questions/22252/how-to-typeset-function-restrictions
\newcommand{\restrict}[2]{{% we make the whole thing an ordinary symbol
    \left.\kern-\nulldelimiterspace % automatically resize the bar with \right
    #1 % the function
    \littletaller % pretend it's a little taller at normal size
    \right|_{#2} % this is the delimiter
}}

\newcommand{\littletaller}{\mathchoice{\vphantom{\big|}}{}{}{}}

% Pour algèbre et maths discrètes
\newcommand{\pgcd}{\ensuremath{\text{ pgcd }}}
\newcomand{\ppcm}{\ensuremath{\text{ ppcm}}}

% Pour tout, ensemble des parties
\newcommand{\powerset}{\ensuremath{\mathcal{P}}}

% Pour analyse, intégrales multiples
\newcommand{\vol}{\ensuremath{\text{ vol}_n}}

% Pour algèbre, ensemble de bijections (recul, vision d'ensemble, théorie de catégories)
\newcommand{\Bij}{\ensuremath{\text{ Bij}}}

% Pour algèbre, actions de groupe, stabilisateur
\newcommand{\Stab}{\ensuremath{\text{ Stab}}}

% Pour algèbre, actions de groupe, orbite d'un élément
\newcommand{\Orb}{\ensuremath{\text{ Orb}}}

% Pour algèbre et géométrie, groupe de permutations de degré n ou groupe symétrique d'indice n
\newcommand{\Sym}{\ensuremath{\text{ Sym}}}

% Blackboard-bold C
\newcommand{\C}{\ensuremath{\mathbb{C}}}

% Blackboard-bold R
\newcommand{\R}{\ensuremath{\mathbb{R}}}

% Blackboard-bold Q
\newcommand{\Q}{\ensuremath{\mathbb{Q}}}

% Blackboard-bold Z
\newcommand{\Z}{\ensuremath{\mathbb{Z}}}

% Blackboard-bold N
\newcommand{\N}{\ensuremath{\mathbb{N}}}

% Script l
\newcommand{\l}{\ensuremath{\mathscr{l}}}

% Blackboard-bold 0
\newcommand{\Zero}{\ensuremath{\mathbb{0}}}

% Blackboard-bold 1
\newcommand{\One}{\ensuremath{\mathbb{1}}}

% Blackboard-bold A
\newcommand{\A}{\ensuremath{\mathbb{A}}}

% Script C for "classe combinatoire" - for Discrete Mathematics
\newcommand{\cc}{\ensuremath{\mathscr{C}}}

% Script D for combinatorial class - for Discrete Mathematics
\newcommand{\dd}{\ensuremath{\mathscr{D}}}

% Pour dénoter l'ensemble des séries formelles sur A de variable X - for Discrete Mathematics
\newcommand{\ringA}[1]{\ensuremath{\mathbb{A}\llbracket #1 \rrbracket}}

% Ordinary generating function - for Discrete Mathematics
\newcommand{\gen}[1]{\ensuremath{\sum_{n \geq 0} #1_n X^n}}

% Exponential generating function - for Discrete Mathematics
\newcommand{\expgen}{1}{\ensuremath{\sum_{n \geq 0} {#1}_n \frac{X^n}{n!}}}

% Shortcut for defining a sequence over the naturals (including zero) - for Analysis and Discrete Mathematics
\newcommand{\seq}[1]{\ensuremath{(#1_n)_{n \in \mathbb{N}}}}


\newcommand{\limpt}{\ensuremath{\mathscr{l}}}

% -------------------- Text Shortcuts -----------------------
\newcommand{\cad}{c'est-à-dire }
\newcommand{\ssi}{si et seulement si }
\newcommand{\ssgrp}{sous-groupe }
\newcommand{\ssens}{sous-ensemble }
\newcommand{\resp}{respectivement }
\newcommand{\sge}{série génératrice exponentielle }


% ------------------------------------------------------------------
% ---------------------BOXED ENVIRONMENTS --------------------------
% ------------------------------------------------------------------

% \RequirePackage[dvipsnames]{xcolor}
% \RequirePackage{tikz}
% \RequirePackage[framemethod=TikZ]{mdframed}

% \mdfdefinestyle{commentboxstyle}{
%     skipabove=1.5\topskip,
%     skipbelow=.5\topskip,
%     rightmargin=0pt,
%     leftmargin=0pt,
%     innerrightmargin=7pt,
%     innerleftmargin=7pt,
%     topline=false,
%     bottomline=false,
%     rightline=false,
%     leftline=false,
%     frametitlerule=true,
%     linecolor=black,
%     fontcolor=black,
% % frametitlebackgroundcolor=RoyalBlue,
% }

% \newmdenv[
%     style=commentboxstyle,
%     backgroundcolor=RoyalBlue!25!White,
%     frametitlebackgroundcolor=RoyalBlue!25!White,
% ]{note}
